/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.gui.nomenclatures;

import java.awt.BorderLayout;
import java.util.Date;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.common.utilities.CocktailConstantes;
import org.cocktail.application.common.utilities.CocktailFormats;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.mangue.modele.grhum.EOCorps;
import org.cocktail.mangue.modele.mangue.EOCorpsPromouvable;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class NomenclatureCorpsPromouvablesView extends javax.swing.JPanel {


	private static final long serialVersionUID = -7770031412248058797L;

	protected EODisplayGroup eodCorpsEchelon, eodCorpsChevron;
	protected ZEOTable myEOTableCorpsEchelon, myEOTableCorpsChevron;
	protected ZEOTableModel myTableModelCorpsEchelon, myTableModelCorpsChevron;
	protected TableSorter myTableSorterCorpsEchelon, myTableSorterCorpsChevron;

    /** Creates new form TemplateJPanel */
    public NomenclatureCorpsPromouvablesView(EODisplayGroup dgCorpsEchelon, EODisplayGroup dgCorpsChevron) {

        eodCorpsEchelon = dgCorpsEchelon;
        eodCorpsChevron = dgCorpsChevron;
                
        initComponents();
        initGui();
        
    }

	/** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTableCorpsEchelon = new javax.swing.JPanel();
        viewTableCorpsChevron = new javax.swing.JPanel();
        jTextField1 = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        btnAjouterCorpsChevron = new javax.swing.JButton();
        btnModifierCorpsChevron = new javax.swing.JButton();
        btnSupprimerCorpsChevron = new javax.swing.JButton();
        btnAjouterCorpsEchelon = new javax.swing.JButton();
        btnModifierCorpsEchelon = new javax.swing.JButton();
        btnSupprimerCorpsEchelon = new javax.swing.JButton();

        viewTableCorpsEchelon.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableCorpsEchelon.setLayout(new java.awt.BorderLayout());

        viewTableCorpsChevron.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableCorpsChevron.setLayout(new java.awt.BorderLayout());

        jTextField1.setBackground(new java.awt.Color(204, 204, 255));
        jTextField1.setEditable(false);
        jTextField1.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        jTextField1.setText("CORPS PROMOUVABLES ECHELONS");

        jTextField2.setBackground(new java.awt.Color(204, 204, 255));
        jTextField2.setEditable(false);
        jTextField2.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        jTextField2.setText("CORPS PROMOUVALES CHEVRONS");

        btnAjouterCorpsChevron.setToolTipText("Ajouter un corps");

        btnModifierCorpsChevron.setToolTipText("Modification des dates de validité");
        btnModifierCorpsChevron.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnModifierCorpsChevronActionPerformed(evt);
            }
        });

        btnSupprimerCorpsChevron.setToolTipText("Supprimer le corps sélectionné");

        btnAjouterCorpsEchelon.setToolTipText("Ajouter un corps");

        btnModifierCorpsEchelon.setToolTipText("Modification des dates de validité");

        btnSupprimerCorpsEchelon.setToolTipText("Supprimer le corps sélectionné");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(jTextField1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 375, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnAjouterCorpsEchelon, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnModifierCorpsEchelon, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSupprimerCorpsEchelon, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(viewTableCorpsEchelon, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 459, Short.MAX_VALUE))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(jTextField2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 368, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnAjouterCorpsChevron, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnModifierCorpsChevron, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSupprimerCorpsChevron, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(viewTableCorpsChevron, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 452, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(btnAjouterCorpsEchelon, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnModifierCorpsEchelon, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnSupprimerCorpsEchelon, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(layout.createSequentialGroup()
                                .add(2, 2, 2)
                                .add(jTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewTableCorpsEchelon, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 643, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jTextField2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(btnAjouterCorpsChevron, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(btnModifierCorpsChevron, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(btnSupprimerCorpsChevron, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .add(8, 8, 8)
                        .add(viewTableCorpsChevron, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 641, Short.MAX_VALUE)))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnModifierCorpsChevronActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnModifierCorpsChevronActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_btnModifierCorpsChevronActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JButton btnAjouterCorpsChevron;
    protected javax.swing.JButton btnAjouterCorpsEchelon;
    protected javax.swing.JButton btnModifierCorpsChevron;
    protected javax.swing.JButton btnModifierCorpsEchelon;
    protected javax.swing.JButton btnSupprimerCorpsChevron;
    protected javax.swing.JButton btnSupprimerCorpsEchelon;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    protected javax.swing.JPanel viewTableCorpsChevron;
    protected javax.swing.JPanel viewTableCorpsEchelon;
    // End of variables declaration//GEN-END:variables

        private void initGui() {

    	btnAjouterCorpsEchelon.setIcon(CocktailIcones.ICON_ADD);
    	btnModifierCorpsEchelon.setIcon(CocktailIcones.ICON_UPDATE);
    	btnSupprimerCorpsEchelon.setIcon(CocktailIcones.ICON_DELETE);

    	btnAjouterCorpsChevron.setIcon(CocktailIcones.ICON_ADD);
    	btnModifierCorpsChevron.setIcon(CocktailIcones.ICON_UPDATE);
    	btnSupprimerCorpsChevron.setIcon(CocktailIcones.ICON_DELETE);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eodCorpsEchelon, EOCorpsPromouvable.CORPS_KEY+"."+EOCorps.LL_CORPS_KEY, "Libellé Corps", 225);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodCorpsEchelon, EOCorpsPromouvable.D_DEB_VAL_KEY, "Ouverture", 75);
    	col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);
		col.setColumnClass(Date.class);
    	myCols.add(col);

		myTableModelCorpsEchelon = new ZEOTableModel(eodCorpsEchelon, myCols);
		myTableSorterCorpsEchelon = new TableSorter(myTableModelCorpsEchelon);

		myEOTableCorpsEchelon = new ZEOTable(myTableSorterCorpsEchelon);
		//myEOTable.addListener(myListenerContrat);
		myTableSorterCorpsEchelon.setTableHeader(myEOTableCorpsEchelon.getTableHeader());		

		myEOTableCorpsEchelon.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableCorpsEchelon.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableCorpsEchelon.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableCorpsEchelon.setLayout(new BorderLayout());
		viewTableCorpsEchelon.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableCorpsEchelon.removeAll();
		viewTableCorpsEchelon.add(new JScrollPane(myEOTableCorpsEchelon), BorderLayout.CENTER);

		myCols = new Vector<ZEOTableModelColumn>();

    	col = new ZEOTableModelColumn(eodCorpsChevron, EOCorpsPromouvable.CORPS_KEY+"."+EOCorps.LL_CORPS_KEY, "Libellé Corps", 225);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodCorpsChevron, EOCorpsPromouvable.D_DEB_VAL_KEY, "Ouverture", 75);
    	col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);
		col.setColumnClass(Date.class);
    	myCols.add(col);

		myTableModelCorpsChevron = new ZEOTableModel(eodCorpsChevron, myCols);
		myTableSorterCorpsChevron = new TableSorter(myTableModelCorpsChevron);

		myEOTableCorpsChevron = new ZEOTable(myTableSorterCorpsChevron);
		//myEOTable.addListener(myListenerContrat);
		myTableSorterCorpsChevron.setTableHeader(myEOTableCorpsChevron.getTableHeader());		

		myEOTableCorpsChevron.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableCorpsChevron.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableCorpsChevron.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableCorpsChevron.setLayout(new BorderLayout());
		viewTableCorpsChevron.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableCorpsChevron.removeAll();
		viewTableCorpsChevron.add(new JScrollPane(myEOTableCorpsChevron), BorderLayout.CENTER);

    }

		public ZEOTable getMyEOTableCorpsEchelon() {
			return myEOTableCorpsEchelon;
		}

		public void setMyEOTableCorpsEchelon(ZEOTable myEOTableCorpsEchelon) {
			this.myEOTableCorpsEchelon = myEOTableCorpsEchelon;
		}

		public ZEOTable getMyEOTableCorpsChevron() {
			return myEOTableCorpsChevron;
		}

		public void setMyEOTableCorpsChevron(ZEOTable myEOTableCorpsChevron) {
			this.myEOTableCorpsChevron = myEOTableCorpsChevron;
		}

		public javax.swing.JButton getBtnAjouterCorpsChevron() {
			return btnAjouterCorpsChevron;
		}

		public void setBtnAjouterCorpsChevron(javax.swing.JButton btnAjouterCorpsChevron) {
			this.btnAjouterCorpsChevron = btnAjouterCorpsChevron;
		}

		public javax.swing.JButton getBtnAjouterCorpsEchelon() {
			return btnAjouterCorpsEchelon;
		}

		public void setBtnAjouterCorpsEchelon(javax.swing.JButton btnAjouterCorpsEchelon) {
			this.btnAjouterCorpsEchelon = btnAjouterCorpsEchelon;
		}

		public javax.swing.JButton getBtnModifierCorpsChevron() {
			return btnModifierCorpsChevron;
		}

		public void setBtnModifierCorpsChevron(
				javax.swing.JButton btnModifierCorpsChevron) {
			this.btnModifierCorpsChevron = btnModifierCorpsChevron;
		}

		public javax.swing.JButton getBtnModifierCorpsEchelon() {
			return btnModifierCorpsEchelon;
		}

		public void setBtnModifierCorpsEchelon(
				javax.swing.JButton btnModifierCorpsEchelon) {
			this.btnModifierCorpsEchelon = btnModifierCorpsEchelon;
		}

		public javax.swing.JButton getBtnSupprimerCorpsChevron() {
			return btnSupprimerCorpsChevron;
		}

		public void setBtnSupprimerCorpsChevron(
				javax.swing.JButton btnSupprimerCorpsChevron) {
			this.btnSupprimerCorpsChevron = btnSupprimerCorpsChevron;
		}

		public javax.swing.JButton getBtnSupprimerCorpsEchelon() {
			return btnSupprimerCorpsEchelon;
		}

		public void setBtnSupprimerCorpsEchelon(
				javax.swing.JButton btnSupprimerCorpsEchelon) {
			this.btnSupprimerCorpsEchelon = btnSupprimerCorpsEchelon;
		}

        
    
    
}
